(function() {
    "use strict";

    angular.module("weChatApp")
        .factory("UserService", ["$q", "Endpoints", UserService])
    ;

    function UserService($q, endpoints) {
        var service = this;

        service.getCurrentUser = function() {
            var deferred = $q.defer();

            endpoints.fetchCurrentUserId().then(function(userId) {
                endpoints.fetchUserById(userId).then(function(resp) {
                    deferred.resolve(resp.User[0]);
                });
            });

            return deferred.promise;
        };

        service.getUsersByTerritories = function(territoryIds) {
            var deferred = $q.defer();
            endpoints.fetchUsersByTerritoryIds(territoryIds).then(deferred.resolve, deferred.reject);
            return deferred.promise;
        };

        service.getUsersByTerritories2 = function(territoryIds) {
            var deferred = $q.defer();
            endpoints.fetchUsersByTerritory2Ids(territoryIds).then(deferred.resolve, deferred.reject);
            return deferred.promise;
        };

        service.getUsersByIds = function(userIds) {
            var deferred = $q.defer();
            endpoints.fetchUserByIds(userIds).then(deferred.resolve, deferred.reject);
            return deferred.promise;
        };

        return service;
    }
}());
